///////////////////////////////////////////////////////////////////////////////
//
//			  Instalator MYIP SERVER
//			         ver 0.1
//			
//
//   Kompilacja: make
//
///////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "select_value.c"

#define CONFIG_FILENAME "mserverMYIP.config"

#define PORT "8750" //port tcp/ip na ktorym nasluchuje serwer
char port[20] = PORT;


//-----------------------------------------------------------------------------
//--------------------------------- CONFIG ------------------------------------
//odczytuje dane z pliku konfiguracyjnego
int read_config(void) {

	char*st  = (char*)malloc(1000*sizeof(char));
	char*out = (char*)malloc(1000*sizeof(char));
	char*p;

	FILE*fd = fopen(CONFIG_FILENAME,"r");
	if(fd==NULL) {free(st); free(out); return -1;}

	while(fgets(st,1000,fd)!=NULL) {
	p = strstr(st, "PORT_MYIP");
	if(p != NULL && st[0]!='#') { 
	   	select_value(st,"PORT_MYIP",out);
	   	if(strcmp(out,"NULL")!=0) strcpy(port,out);
	        }	
	}
	free(st);
	free(out);
	fclose(fd);
	return 0;
}
//-------------------------------- END CONFIG ---------------------------------
//-----------------------------------------------------------------------------



int main() {

  //sprawdza czy logowanie jest na root
  if(getuid() != 0) {
		printf("\n Login as root!\n\n");
		return 0;
  }


printf("\nInstalacja Serwera Centralnego\n\n");

char firewall1[200];
char firewall2[200];

//tworzy katalog montowania pozostalych katalogow
umask(0);
mkdir("DISK",0777);

//nadanie praw exec dla instalowanych plikow");
system("chmod a+x BIN/mserverMYIP");
system("chmod a+x start_server");
system("chmod a+x stop_server");
system("chmod a+x BIN/sync_time");


printf(" --- PORT ---\n");

 read_config();

//otwieranie portu tcp/ip
//system("sudo firewall-cmd --zone=public --permanent --add-port=8750/tcp");
//system("sudo firewall-cmd --zone=home --permanent --add-port=8750/tcp");
strcpy(firewall1, "sudo firewall-cmd --zone=public --permanent --add-port=");
strcat(firewall1, port);
strcat(firewall1,"/tcp");

strcpy(firewall2, "sudo firewall-cmd --zone=home --permanent --add-port=");
strcat(firewall2, port);
strcat(firewall2,"/tcp");
system(firewall1);
system(firewall2);

//otwiera port ntp
system("sudo firewall-cmd --zone=public --add-port=123/udp --permanent");

//reload firewall
system("sudo firewall-cmd --reload");
system("sudo firewall-cmd --list-ports");


printf("\n         --- Koniec Instalacji Systemu ---\n\n");


return 0;
}
