/******************************************************************************
 *
 *                                   ARCHI
 *	                              executorMYIP
 *	                                ver 0.2
 *	                         (lib. for mserverMYIP)
 *                               (JPW - 2019)
 *
 *
 ******************************************************************************
 */



#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifndef SELECT 
#define SELECT
#include "SRC/select_value.c" 
#endif


#include "exec_functions_MYIP.c"



#define TEST_H00 "REPLY=mserverMYIP&" //<-- id serwera 





//---------------------------------- ANALIZATOR ------------------------------- 

int analizator(const char*in, char*out, const char*ip_client) {

	char value[80];
        char test_h00[80];


	//--- test obecnosci serwera ---
	//query: TEST=H00&; 
	//reply: "REPLY=mserverMYIP&"
	select_value(in,"TEST",test_h00);
	if(strcmp(test_h00,"H00")==0) {
		strcpy(out,TEST_H00); 
		return 1;
	}


	select_value(in,"OP",value);

	

	// --- odsyla IP ---
	
	// IP=...&
	if(strcmp(value,"my_ip")==0) {
	return my_ip(ip_client, out);
	}


	// IP=...&SEC=<sekundy>&NS=<nanasec>&
	if(strcmp(value,"my_ip_time")==0) {
	return my_ip_time(ip_client, out);
	}

	


	// --- version ---
	
	//OP=versionMYIP&
	//RE=versionMYIP&VER=..&SYS=...&
	//lub
	//RE=versionMYIP&VER=null&SYS=null&CP=<powod bledu>&
	if(strcmp(value, "versionMYIP")==0) {
	return versionMYIP(in, out);
	}




    strcpy(out,"I love you.");
    return -2;	
}
//-------------------------------- END Analizator -----------------------------




///////////////////////////////////////////////////////////////////////////////
//-------------------------------- INTERFACE ----------------------------------
///////////////////////////////////////////////////////////////////////////////
int executor(char*input, const char*ip_client) {

   int ret; 

   //char txt[HEADSIZE]; //szyfrowany

   //fprintf(stdout,"Client's IP : %s\n", ip_client); //<----------- test
   //fflush(stdout); //<-------------------------------------------- test	  

   //--- decoder ---
   //decodeV1(input, 0, txt);//decoder

   /* --- shows task q-string on the screen ---*/
   if(test_mode) {
	//fprintf(stdout,"EXEC REC[2]: %s\n", txt);// szyfrowany
	fprintf(stdout,"EXEC REC[2]: %s\n", input);
	fflush(stdout);		
   }

       
	/* --- go to anaslisis of task --- */
	//ret = analizator(txt, txt, ip_client); //szyfrowny
	ret = analizator(input, input, ip_client); //nie szyfrowany
        if(ret==-2) {
            if(test_mode) printf("TEST: I love you.\n");
            strcpy(input, "I love you.");
            return 0;
        }


   /* --- shows task q-string on the screen ---*/
   if(test_mode)  {
	//fprintf(stdout,"EXEC OUT[2]: %s\n", txt);// szyfrowany
	fprintf(stdout,"EXEC OUT[2]: %s\n", input); //nieszyrowany
	fflush(stdout);		
   }

   //--- encoder ---
   //codeV1(txt, 0, input);

   return ret;
}
///////////////////////////////////////////////////////////////////////////////
//-------------------------------- INTERFACE ----------------------------------
///////////////////////////////////////////////////////////////////////////////

