///////////////////////////////////////////////////////////////////////////////
//
//                    Wczytuje dane z pliku konfiguracyjnego
//
//                              (JPW-2019)
//
//
///////////////////////////////////////////////////////////////////////////////


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#ifndef SELECT 
#define SELECT
#include "SRC/select_value.c" 
#endif



#define CONFIG_FILENAME "mserverMYIP.config"


// --- zmienne globalne ---

#define PORT 8809 //definjujemy port nasluchiwania
int  port_myip = PORT;


#define TEST_MODE 0 //0-nie robi printf, 1 -pokazuje na ekranie
int test_mode=TEST_MODE;

// --- koniec zmienne globalne ---





//odczytuje dane z pliku konfiguracyjnego
int read_config(void) {

	char*p;

	char*st  = (char*)malloc(1000*sizeof(char));
	char*out = (char*)malloc(1000*sizeof(char));

	FILE*fd = fopen(CONFIG_FILENAME,"r");
	if(fd==NULL) {free(st); free(out); return -1;}

	while(fgets(st,1000,fd)!=NULL) {
			
		p = strstr(st, "PORT_MYIP");
		if(p != NULL && st[0] != '#') {
	   		select_value(st,"PORT_MYIP",out);
	   		if(strcmp(out,"NULL")!=0) port_myip = atoi(out);
		}

		//flaga "show internal errors" przy testowaniu serwera
		p = strstr(st, "TEST");
		if (p != NULL && st[0] != '#') {
			select_value(st,"TEST",out);
			if(strcmp(out,"1")==0) test_mode=1;
			else test_mode=0;
		}
	}
	


	free(st);
	free(out);
	fclose(fd);
	return 0;
}




